%

function []=CrossPlotMatches(v11,v12,v21,v22,va1,va2,linlog1,linlog2,var1name,var2name,vardir,slope,intercept,slopeortho,interceptortho,slopeall,interceptall,slopeallortho,interceptallortho,extorall,vertorortho,greyplot,fsize)


% v11
% v12
% v21
% v22
% va1
% va2
% linlog1
% linlog2
% var1name
% var2name
% vardir
% slope
% intercept
% slopeortho
% interceptortho
% slopeall
% interceptall
% slopeallortho
% interceptallortho
% extorall
% vertorortho
% fsize

%v11
%v12
%v21
%v22
%va1
%va2
%linlog1
%linlog2
%var1name
%var2name
%extorall: -1 for extrema only, 1 for intermediary only, 0 for all
%vertorortho: -1 for vertical LS, +1 for orthogonal, 0 for both
%fsize

if linlog1, v11=abs(v11);v21=abs(v21);va1=abs(va1);end
if linlog2, v12=abs(v12);v22=abs(v22);va2=abs(va2);end

if nargin<12
    fsize=12;%22 good for presentations; 12 for papers;
end
if nargin<11
    greyplot=0;%grey is good for presentations;
end


%Plots of TransectAnalysis.m without color inversion
fontchoiceorder={'GaramondPremrPro-Smbd','new century schoolbook','century schoolbook l','times new roman','Helvetica'};

lfonts=listfonts;
for i=1:length(fontchoiceorder)
    fontnamei=fontchoiceorder(i);
    isgoodfont=strcmpi(lfonts,fontnamei);
    if ismember(1,isgoodfont)
        fontname=char(fontnamei);
        break
    elseif i==length(fontchoiceorder)
        fontname=get(0,'DefaultAxesFontName');
    end
end
clear fontnamei;
display(['The font used for the plot is: ' fontname])
%fsize=22;
set(0, 'DefaultAxesFontName', fontname, 'DefaultTextFontName', fontname, 'DefaultAxesFontSize',12, 'DefaultTextFontSize',12,'DefaultLineLineWidth', 2,'DefaultAxesFontWeight','bold','DefaultTextFontWeight','bold');

%Legend preparation
if vardir==1
    extstr1=['Minima of ' var1name ', minima of ' var2name];
    extstr2=['Maxima of ' var1name ', maxima of ' var2name];
elseif vardir==-1
    extstr1=['Minima of ' var1name ', maxima of ' var2name];
    extstr2=['Maxima of ' var1name ', minima of ' var2name];
end
% corint=['Corresponding values of ' var1name ' and ' var2name ' (intermediary values)'];
corstr=['All corresponding values of ' var1name ' and ' var2name];

extfitvert=['Extrema (vert): ' var2name '='];
extfitortho=['Extrema (ortho): ' var2name '='];
allfitvert=['All points (vert): ' var2name '='];
allfitortho=['All points (ortho): ' var2name '='];

if linlog1&&linlog2
    extfitvert=[extfitvert num2str(rounddec(intercept,2)) ' x ' var1name ' ^{' num2str(rounddec(slope,2)) '}'];
    extfitortho=[extfitortho num2str(rounddec(interceptortho,2)) ' x ' var1name ' ^{' num2str(rounddec(slopeortho,2)) '}'];
    allfitvert=[allfitvert num2str(rounddec(interceptall,2)) ' x ' var1name ' ^{' num2str(rounddec(slopeall,2)) '}'];
    allfitortho=[allfitortho num2str(rounddec(interceptallortho,2)) ' x ' var1name ' ^{' num2str(rounddec(slopeallortho,2)) '}'];
elseif linlog1&&(~linlog2)
    extfitvert=[extfitvert num2str(rounddec(slope,2)) ' x log_{10}(' var1name ') + ' num2str(rounddec(intercept,2))];
    extfitortho=[extfitortho num2str(rounddec(slopeortho,2)) ' x log_{10}(' var1name '} +' num2str(rounddec(interceptortho,2))];
    allfitvert=[allfitvert num2str(rounddec(slopeall,2)) ' x log_{10}(' var1name ') + ' num2str(rounddec(interceptall,2))];
    allfitortho=[allfitortho num2str(rounddec(slopeallortho,2)) ' x log_{10}(' var1name '} +' num2str(rounddec(interceptallortho,2))];
elseif (~linlog1)&&linlog2
    extfitvert=[extfitvert num2str(rounddec(intercept,2)) ' x ' var1name ' ^{' num2str(rounddec(slope,2)) '}'];
    extfitortho=[extfitortho num2str(rounddec(interceptortho,2)) ' x ' var1name ' ^{' num2str(rounddec(slopeortho,2)) '}'];
    allfitvert=[allfitvert num2str(rounddec(interceptall,2)) ' x ' var1name ' ^{' num2str(rounddec(slopeall,2)) '}'];
    allfitortho=[allfitortho num2str(rounddec(interceptallortho,2)) ' x ' var1name ' ^{' num2str(rounddec(slopeallortho,2)) '}'];
else
    extfitvert=[extfitvert num2str(rounddec(slope,2)) ' x ' var1name ' + ' num2str(rounddec(intercept,2))];
    extfitortho=[extfitortho num2str(rounddec(slopeortho,2)) ' x ' var1name ' +' num2str(rounddec(interceptortho,2))];
    allfitvert=[allfitvert num2str(rounddec(slopeall,2)) ' x ' var1name ' + ' num2str(rounddec(interceptall,2))];
    allfitortho=[allfitortho num2str(rounddec(slopeallortho,2)) ' x ' var1name ' +' num2str(rounddec(interceptallortho,2))];
end

j=0;
lege=struct2cell(struct([]));
if extorall<=0
    j=j+1;lege{1,j}=extstr1;
    j=j+1;lege{1,j}=extstr2;
    if vertorortho<=0
        j=j+1;lege{1,j}=extfitvert;
    end
    if vertorortho>=0
        j=j+1;lege{1,j}=extfitortho;
    end
end
if extorall>=0
    j=j+1;lege{1,j}=corstr;
    if vertorortho<=0
        j=j+1;lege{1,j}=allfitvert;
    end
    if vertorortho>=0
        j=j+1;lege{1,j}=allfitortho;
    end
end

%End of legend preparation

minx=min([va1;v11;v21]);
maxx=max([va1;v11;v21]);
miny=min([va2;v12;v22]);
maxy=max([va2;v12;v22]);
if linlog1, minx=10^(floor(log10(minx)));maxx=10^(ceil(log10(maxx)));else minx=floor(minx);maxx=ceil(maxx);end
if linlog2, miny=10^(floor(log10(miny)));maxy=10^(ceil(log10(maxy)));else miny=floor(miny);maxy=ceil(maxy);end

if linlog1, var1interp=logspace(log10(minx),log10(maxx),10000);else var1interp=linspace(minx,maxx,10000);end

if linlog2
    var2interpall=interceptall*var1interp.^slopeall;
    var2interp=intercept*var1interp.^slope;
    var2interpallortho=interceptallortho*var1interp.^slopeallortho;
    var2interportho=interceptortho*var1interp.^slopeortho;
else
    if linlog1
        var2interpall=slopeall.*log10(var1interp)+interceptall;
        var2interp=slope.*log10(var1interp)+intercept;
        var2interpallortho=slopeallortho.*log10(var1interp)+interceptallortho;
        var2interportho=slopeortho.*log10(var1interp)+interceptortho;
    else
        var2interpall=slopeall.*var1interp+interceptall;
        var2interp=slope.*var1interp+intercept;
        var2interpallortho=slopeallortho.*var1interp+interceptallortho;
        var2interportho=slopeortho.*var1interp+interceptortho;
    end
end

%TDinterpall=(Rinterp.^Ptdrall(1)).*(10^(Ptdrall(2)));

%extorall: -1 for extrema only, 1 for intermediary only, 0 for all
%vertorortho: -1 for vertical LS, +1 for orthogonal, 0 for both
OldColours=[.65 .3 .95;
    .95 .3 .65;
    .65 0 .95;
    .95 0 .65;
    .75 .75 0;
    .95 .65 .3;
    .65 .95 0];

Grey=[1 1 1]/2;
if greyplot
    Colours=hsv(14);
else
    Colours=lines(14);%jet(14);
end
Colours=Colours(1:2:end,:);

figure;hold on;
if extorall<=0
    plot(v11,v12,'Marker','+','LineStyle','none','MarkerSize',7,'LineWidth',2,'Color',Colours(1,:));grid on;
    plot(v21,v22,'Marker','x','LineStyle','none','MarkerSize',8,'LineWidth',2,'Color',Colours(2,:));grid on;
    if vertorortho<=0
        plot(var1interp,var2interp,'LineStyle',':','LineWidth',2,'Color',Colours(3,:));hold on;
    end
    if vertorortho>=0
        plot(var1interp,var2interportho,'LineStyle','--','LineWidth',2,'Color',Colours(4,:));hold on;
    end
end
if extorall>=0
    plot(va1,va2,'Marker','d','LineStyle','none','MarkerSize',6,'LineWidth',2,'Color',Colours(5,:));grid on;
    if vertorortho<=0
        plot(var1interp,var2interpall,'LineStyle','-.','LineWidth',2,'Color',Colours(6,:));hold on;
    end
    if vertorortho>=0
        plot(var1interp,var2interpallortho,'LineStyle','-','LineWidth',2,'Color',Colours(7,:));hold on;
    end
end
leg=legend(lege);
if linlog1
    set(gca,'XScale','log');
end
if linlog2
    set(gca,'YScale','log');
end
set(gca,'XLim',[minx maxx],'YLim',[miny maxy]);
set(leg,'LineWidth',2,'FontSize',fsize,'FontWeight','bold','FontName',fontname,'Location','SouthWest');%,'Interpreter','Latex');
xlabel(var1name,'FontWeight','bold','FontSize',fsize,'FontName',fontname);%
ylabel(['Corresponding values of ' var2name],'FontWeight','bold','FontSize',fsize,'FontName',fontname);%
title(['Corresponding values of ' var1name ' and ' var2name],'FontWeight','bold','FontSize',fsize,'FontName',fontname);%
set(gca,'LineWidth',2,'FontSize',fsize,'FontWeight','bold','FontName',fontname,'YMinorGrid','off','XMinorGrid','off');%
set(gcf,'PaperOrientation','landscape','Color',[1 1 1],'Papersize',[11 8.5],'PaperPosition',[0 0 11 8.5]);%
if greyplot
    set(get(gca,'XLabel'),'color','w');
    set(get(gca,'YLabel'),'color','w');
    set(get(gca,'Title'),'color','w');
    set(leg,'Color',Grey,'EdgeColor','w','TextColor','w');
    set(gca,'Color',Grey,'XColor',[1 1 1],'YColor',[1 1 1]);
    set(gcf,'Color',Grey,'InvertHardCopy','off');
end





function [xround]=rounddec(x,prec)
xround=real(round((10^(prec-floor(log10(x)))*x))/(10^(prec-floor(log10(x)))));%real to avoid numerical errors that cause imaginary values...

% figure;
% loglog(Rinterp,TDinterpall,'LineStyle','-.','LineWidth',2,'Color',[.5 0 .5]);hold on;
% loglog(Rinterp,TDinterp,'LineStyle','-.','LineWidth',2,'Color',[1 0 1]);
% loglog(logspace(2+log10(2),4+log10(2),10000),oao1*(logspace(2+log10(2),4+log10(2),10000).^(slo1)),'LineStyle','-','LineWidth',2,'Color',[0 0 0]);
% loglog(logspace(3,7,10000),oao2*(logspace(3,7,10000).^(slo2)),'LineStyle','-','LineWidth',2,'Color',[0 0 0]);
% loglog(RTDmatch(:,1),RTDmatch(:,2),'Marker','.','LineStyle','none','MarkerSize',6,'LineWidth',2,'Color',[.5 0 .5]);grid on;
% xlims=get(gca,'XLim');ylims=get(gca,'YLim');xlims(2)=10^0;xlims(2)=10^7;ylims(2)=10^0;ylims(2)=10^2;hold on;
% loglog(matchTDRTDR(:,1),matchTDRTDR(:,2),'Marker','+','LineStyle','none','MarkerSize',6,'LineWidth',2,'Color',[0 0 1]);
% loglog(matchRTDRTD(:,1),matchRTDRTD(:,2),'Marker','+','LineStyle','none','MarkerSize',6,'LineWidth',2,'Color',[1 0 0]);
% % loglog(logspace(4,7,10000),oao2*(logspace(4,7,10000).^(slo2)),'LineStyle','-','LineWidth',2,'Color',[0 0 0]);
% % loglog(logspace(2,5,10000),oao1*(logspace(2,5,10000).^(slo1)),'LineStyle','-','LineWidth',2,'Color',[0 0 0]);
% set(gca,'XLim',xlims,'YLim',ylims);
% if Ptdrall(2)>=3, P2roundtdrallRS=round(10^(Pall(2))); else P2roundtdrallRS=round(10^(Ptdrall(2))*1000)/1000;, end
% if Ptdr(2)>=3, P2roundtdr=roundtdr(10^(P(2)));, else, P2roundtdr=round(10^(Ptdr(2))*1000)/1000;, end
% leg=legend(['|S|=' num2str(P2roundtdrallRS) '\times |R|^{' num2str(Ptdrall(1)) '}; r^2=' num2str(cctdrall(1,2)^2)],['|S|=' num2str(P2roundtdr) '\times |R|^{' num2str(Ptdr(1)) '}; r^2=' num2str(ccRRTDTD(1,2)^2)],'Outlier delimiters');
% set(leg,'LineWidth',2,'FontSize',fsize,'FontWeight','bold','FontName',fontname,'Location','SouthWest');%,'Interpreter','Latex');
% xlabel('Radii of curvature (m)','FontWeight','bold','FontSize',fsize,'FontName',fontname);%
% ylabel('Corresponding values of total relief (m)','FontWeight','bold','FontSize',fsize,'FontName',fontname);%
% title(['Corresponding values of Radius of curvature and total relief'],'FontWeight','bold','FontSize',fsize,'FontName',fontname);%
% set(gca,'LineWidth',2,'FontSize',fsize,'FontWeight','bold','FontName',fontname);%
% set(gcf,'PaperOrientation','landscape','Color',[1 1 1],'Papersize',[11 8.5],'PaperPosition',[0 0 11 8.5]);%