%Example file for Trinity River, 1952 dataset
%
%(c) Aymeric-Pierre B. Peyret 2010-2011
% Input files (c) Virginia Smith

% Loading data
data1952=load('Trinity1952.txt');
LeftOuterBankX=data1952(:,1);
LeftOuterBankY=data1952(:,2);
LeftInnerBankX=data1952(:,3);
LeftInnerBankY=data1952(:,4);
CenterLineX=data1952(:,5);
CenterLineY=data1952(:,6);
RightInnerBankX=data1952(:,7);
RightInnerBankY=data1952(:,8);
RightOuterBankX=data1952(:,9);
RightOuterBankY=data1952(:,10);

%Cropping data vectors so that only existing data are kept
[isdatal,isdatac]=find(~isnan(LeftOuterBankX));LeftOuterBankX=LeftOuterBankX(1:max(isdatal));%151-220
[isdatal,isdatac]=find(~isnan(LeftOuterBankY));LeftOuterBankY=LeftOuterBankY(1:max(isdatal));
[isdatal,isdatac]=find(~isnan(LeftInnerBankX));LeftInnerBankX=LeftInnerBankX(1:max(isdatal));
[isdatal,isdatac]=find(~isnan(LeftInnerBankY));LeftInnerBankY=LeftInnerBankY(1:max(isdatal));
[isdatal,isdatac]=find(~isnan(CenterLineX));CenterLineX=CenterLineX(1:max(isdatal));
[isdatal,isdatac]=find(~isnan(CenterLineY));CenterLineY=CenterLineY(1:max(isdatal));
[isdatal,isdatac]=find(~isnan(RightInnerBankX));RightInnerBankX=RightInnerBankX(1:max(isdatal));
[isdatal,isdatac]=find(~isnan(RightInnerBankY));RightInnerBankY=RightInnerBankY(1:max(isdatal));
[isdatal,isdatac]=find(~isnan(RightOuterBankX));RightOuterBankX=RightOuterBankX(1:max(isdatal));
[isdatal,isdatac]=find(~isnan(RightOuterBankY));RightOuterBankY=RightOuterBankY(1:max(isdatal));
clear isdatal isdatac
l1=length(LeftOuterBankX);
l2=length(LeftInnerBankX);
l3=length(CenterLineX);
l4=length(RightInnerBankX);
l5=length(RightOuterBankX);


SL2=5;%half-swipelength
%Running width code with outer banks
[ChanWidthOuter,ChanWidth2Outer,R,coord1outer,coord2outer,width1outer,width2outer,Ox,Oy,xdir,ydir,coordfilt,bankfilt1,bankfilt2]=Width(CenterLineX,CenterLineY,LeftOuterBankX,LeftOuterBankY,RightOuterBankX,RightOuterBankY,21,1,0,SL2*2+1,0);

%Comparing "direct" outer width with outer width computer when going
%through centerline point. Should not be much difference, hence  points not
%close to y=x line indicate problems
figure;
plot(ChanWidthOuter,ChanWidth2Outer,'+');
hold on;
plot(linspace(0,max(max(ChanWidthOuter),max(ChanWidth2Outer)),1000),linspace(0,max(max(ChanWidthOuter),max(ChanWidth2Outer)),1000),'r')
problematicpoints=find(abs(ChanWidth2Outer./ChanWidthOuter-1)>=.1);
novaluepoints=find(isnan(ChanWidthOuter));

%Plotting river with filtered centerline dots, filtered outer banks
%crosses, segments joining filtered centerline and filtered bank points
%used for outer-width calculations. Centerline-normal lines are in black
%and show when width was not computed along centerline-normal. Line 58
%circles problematic centerline points
figure;pause
plot(bankfilt1(:,1),bankfilt1(:,2),'kx');% plot(LeftOuterBankX,LeftOuterBankY,'kx');
hold on
plot(coordfilt(:,1),coordfilt(:,2),'b.');% plot(CenterLineX,CenterLineY,'b.');
plot(coordfilt(problematicpoints,1),coordfilt(problematicpoints,2),'ro');
plot(bankfilt2(:,1),bankfilt2(:,2),'gx');% plot(RightOuterBankX,RightOuterBankY,'gx');
[toplot1,temp]=find(~isnan(coord1outer));[toplot2,temp]=find(~isnan(coord2outer));clear temp;
interval=intersect(toplot1,toplot2);
for j=16:length(CenterLineX)
    x31=coordfilt(j,1);%CenterLineX(j);
    x32=ChanWidth2Outer(j)*xdir(j)*.75;
    y31=coordfilt(j,2);%CenterLineY(j);
    y32=ChanWidth2Outer(j)*ydir(j)*.75;
    plot(linspace(x31-x32,x31+x32,1000),linspace(y31-y32,y31+y32,1000),'k-');
    %UNCOMMENT FOLLOWING 3 LINES TO DISPLAY CENTERLINE POINT NUMBER
    %NEAR CENTERLINE POINTS WITH AN INCREMENT of 5.
%     if mod(j,5)==0
%         text(coordfilt(j,1),coordfilt(j,2),num2str(j));%text(CenterLineX(j),CenterLineY(j),num2str(j));
%     end
    if ~isempty(intersect(j,interval))
        x11=coordfilt(j,1);%CenterLineX(j);
        x12=coord1outer(j,1);
        y11=coordfilt(j,2);%CenterLineY(j);
        y12=coord1outer(j,2);
        x21=coordfilt(j,1);%CenterLineX(j);
        x22=coord2outer(j,1);
        y21=coordfilt(j,2);%CenterLineY(j);
        y22=coord2outer(j,2);
        plot(linspace(x11,x12,1000),linspace(y11,y12,1000),'r-');plot(x12,y12,'rx');
        plot(linspace(x21,x22,1000),linspace(y21,y22,1000),'m-');plot(x22,y22,'mx');
    end
end
%FOR PLOTTING POINT NUMBERS FOR THE BANKS TOO, UNCOMMENT FOLLOWING 15 LINES
% for jj=1:length(LeftOuterBankX)
%     if mod(jj,5)==0
%         t=text(LeftOuterBankX(jj),LeftOuterBankY(jj),num2str(jj));
%         %         pause
%         set(t,'Color','r');
%         %         pause
%     end
%     clear t jjj;
% end
% for jjj=1:length(RightOuterBankX)
%     if mod(jjj,5)==0
%         t=text(RightOuterBankX(jjj),RightOuterBankY(jjj),num2str(jjj));set(t,'Color','b');
%     end
%     clear t jjj;
% end
axis tight equal

%Running width code with inner banks
[ChanWidthInner,ChanWidth2Inner,R,coord1inner,coord2inner,width1inner,width2inner,Ox,Oy,xdir,ydir,coordfilt,bankfilt1,bankfilt2]=Width(CenterLineX,CenterLineY,LeftInnerBankX,LeftInnerBankY,RightInnerBankX,RightInnerBankY,21,1,0,SL2*2+1,0);

%same thing as above, for inner banks
problematicpoints=find(abs(ChanWidth2Inner./ChanWidthInner-1)>=.1);
novaluepoints=find(isnan(ChanWidthInner));
% figure;
% % plot(LeftOuterBankX,LeftOuterBankY,'kx');
% plot(LeftInnerBankX,LeftInnerBankY,'kx');
% hold on
% plot(CenterLineX,CenterLineY,'b.');
% plot(RightInnerBankX,RightInnerBankY,'gx');
% % plot(RightOuterBankX,RightOuterBankY,'gx');
% [toplot1,temp]=find(~isnan(coord1inner));[toplot2,temp]=find(~isnan(coord2inner));clear temp;
% interval=intersect(toplot1,toplot2);
% for j=16:length(CenterLineX)
%     if ~isempty(intersect(j,interval))
%         x11=CenterLineX(j);
%         x12=coord1inner(j,1);
%         y11=CenterLineY(j);
%         y12=coord1inner(j,2);
%         x21=CenterLineX(j);
%         x22=coord2inner(j,1);
%         y21=CenterLineY(j);
%         y22=coord2inner(j,2);
%         plot(x11:(x12-x11)/999:x12,y11:(y12-y11)/999:y12,'r-');plot(x12,y12,'rx');
%         plot(x21:(x22-x21)/999:x22,y21:(y22-y21)/999:y22,'m-');plot(x22,y22,'mx');
%         %UNCOMMENT FOLLOWING LINES TO DISPLAY CENTERLINE POINT NUMBER
%         %ABOVVE CENTERLINE POINTS WITH AN INCREMENT of 5.
%         %         if mod(j,5)==0
%         %             text(CenterLineX(j),CenterLineY(j),num2str(j));
%         %         end
%     end
% end
figure;pause
plot(bankfilt1(:,1),bankfilt1(:,2),'kx');% plot(LeftOuterBankX,LeftOuterBankY,'kx');
hold on
% % plot(LeftInnerBankX,LeftInnerBankY,'r');
plot(coordfilt(:,1),coordfilt(:,2),'b.');% plot(CenterLineX,CenterLineY,'b.');
plot(coordfilt(problematicpoints,1),coordfilt(problematicpoints,2),'ro');
% % plot(RightInnerBankX,RightInnerBankY,'m');
plot(bankfilt2(:,1),bankfilt2(:,2),'gx');% plot(RightOuterBankX,RightOuterBankY,'gx');
[toplot1,temp]=find(~isnan(coord1inner));[toplot2,temp]=find(~isnan(coord2inner));clear temp;
interval=intersect(toplot1,toplot2);
for j=16:length(CenterLineX)
    x31=coordfilt(j,1);%CenterLineX(j);
    x32=ChanWidth2Inner(j)*xdir(j)*.75;
    y31=coordfilt(j,2);%CenterLineY(j);
    y32=ChanWidth2Inner(j)*ydir(j)*.75;
    plot(linspace(x31-x32,x31+x32,1000),linspace(y31-y32,y31+y32,1000),'k-');
    %UNCOMMENT FOLLOWING LINES TO DISPLAY CENTERLINE POINT NUMBER
    %ABOVE CENTERLINE POINTS WITH AN INCREMENT of 5.
    if mod(j,20)==0
        text(coordfilt(j,1),coordfilt(j,2),num2str(j));%text(CenterLineX(j),CenterLineY(j),num2str(j));
    end
    if ~isempty(intersect(j,interval))
        x11=coordfilt(j,1);%CenterLineX(j);
        x12=coord1inner(j,1);
        y11=coordfilt(j,2);%CenterLineY(j);
        y12=coord1inner(j,2);
        x21=coordfilt(j,1);%CenterLineX(j);
        x22=coord2inner(j,1);
        y21=coordfilt(j,2);%CenterLineY(j);
        y22=coord2inner(j,2);
        plot(linspace(x11,x12,1000),linspace(y11,y12,1000),'r-');plot(x12,y12,'rx');
        plot(linspace(x21,x22,1000),linspace(y21,y22,1000),'m-');plot(x22,y22,'mx');
    end
end
axis tight equal

%Comparing inner width and outer width. Outer width smaller than inner
%width often means problem with dataset..
figure;
plot(ChanWidthInner,ChanWidthOuter,'+')
hold on
plot((.4:.01:2.6)*10^-3,(.4:.01:2.6)*10^-3,'r-');
axis tight equal

%Any correlation between inner widths and radii of curvature?
figure;
semilogy(ChanWidthInner,abs(R),'+');


%Comparing inner and outer half-widths on one side with the other side.
%Helps finding if the centerline is centered...
figure;
plot(width1inner,width2inner,'+');
hold on
plot(width1outer,width2outer,'r+');
axis tight equal

%Comparing centeredness of centerline in inner and outer cases
figure;
plot(width2inner./width1inner,width2outer./width1outer,'+');
hold on
plot(0:.01:2,(0:.01:2),'r-');
xlim([0 2]);ylim([0 2]);



%SPECIAL BEND
[ChanWidthOuter,R,coord1outer,coord2outer,width1outer,width2outer,mindist1outer,mindist2outer]=Width(CenterLineX,CenterLineY,LeftOuterBankX,LeftOuterBankY,RightOuterBankX,RightOuterBankY,21,1,1,SL2*2+1);
figure;
plot(LeftOuterBankX,LeftOuterBankY,'kx');
hold on
% plot(LeftInnerBankX,LeftInnerBankY,'r');
plot(CenterLineX,CenterLineY,'b.');
% plot(RightInnerBankX,RightInnerBankY,'m');
plot(RightOuterBankX,RightOuterBankY,'gx');
[toplot1,temp]=find(~isnan(coord1outer));[toplot2,temp]=find(~isnan(coord2outer));clear temp;
interval=intersect(toplot1,toplot2);
for j=16:length(CenterLineX)
    if ~isempty(intersect(j,interval))
        x11=CenterLineX(j);
        x12=coord1outer(j,1);
        y11=CenterLineY(j);
        y12=coord1outer(j,2);
        x21=CenterLineX(j);
        x22=coord2outer(j,1);
        y21=CenterLineY(j);
        y22=coord2outer(j,2);
        plot(x11:(x12-x11)/999:x12,y11:(y12-y11)/999:y12,'r-');plot(x12,y12,'rx');
        plot(x21:(x22-x21)/999:x22,y21:(y22-y21)/999:y22,'m-');plot(x22,y22,'mx');
        %UNCOMMENT FOLLOWING LINES TO DISPLAY CENTERLINE POINT NUMBER
        %ABOVVE CENTERLINE POINTS WITH AN INCREMENT of 5.
        %         if mod(j,5)==0
        %             text(CenterLineX(j),CenterLineY(j),num2str(j));
        %         end
    end
end
xlim([-94.87 -94.84]);
ylim([30.48 30.505]);
axis equal
title('Bloated bend, Trinity river 1952','FontWeight','bold','FontSize',12,'FontName','Century');%
set(gca,'LineWidth',2,'FontSize',12,'FontWeight','bold','FontName','Century');%
set(gcf,'PaperOrientation','landscape','Color',[1 1 1],'Papersize',[11 8.5],'PaperPosition',[0 0 11 8.5]);%
% print -depsc2 -tiff -r1200 BloatedBend.eps
% print -djpeg -r300 BloatedBend300.jpg



figure;
plot(LeftOuterBankX(mindist1outer(541):mindist1outer(559)),LeftOuterBankY(mindist1outer(541):mindist1outer(559)),'kx');
hold on
plot(CenterLineX(541:559),CenterLineY(541:559),'b.');
plot(RightOuterBankX(mindist2outer(541):mindist2outer(559)),RightOuterBankY(mindist2outer(541):mindist2outer(559)),'gx');
% print -depsc2 -tiff -r1200 BloatedBend2.eps
% print -djpeg -r300 BloatedBend2300.jpg
round(mindist1outer(542)+(mindist1outer(558)-mindist1outer(542))/(558-542)*((543:557)-542))


nocalcinner=find(isnan(ChanWidthInner));%';
nocalcouter=find(isnan(ChanWidthOuter));%';

dnocalcinner=diff(nocalcinner);
dnocalcouter=diff(nocalcouter);

indinner=find(dnocalcinner~=1);indinnerbeg=indinner(find(diff(indinner)~=1))+1;indinnerend=indinner(find(diff(indinner)~=1)+1);
indouter=find(dnocalcouter~=1);indouterbeg=indouter(find(diff(indouter)~=1))+1;indouterend=indouter(find(diff(indouter)~=1)+1);

nocalcinnerbeg=nocalcinner(indinnerbeg);nocalcinnerend=nocalcinner(indinnerend);
nocalcouterbeg=nocalcouter(indouterbeg);nocalcouterend=nocalcouter(indouterend);

remainingouter=setdiff(nocalcouter,[1 length(ChanWidthOuter)]);
for j=1:length(indouterbeg)
    beg1=nocalcouterbeg(j)-1;
    end1=nocalcouterend(j)+1;
    firstpoint=nocalcouterbeg(j);
    lastpoint=nocalcouterend(j);
    mindist1=round(mindist1outer(beg1)+(mindist1outer(end1)-mindist1outer(beg1))/(end1-beg1)*((firstpoint:lastpoint)-beg1));
    remainingouter=setdiff(remainingouter,firstpoint:lastpoint);
end

