%Example file for Trinity River, 2009 dataset
%
%(c) Aymeric-Pierre B. Peyret 2010-2011
% Input files (c) Virginia Smith


% Loading data
data2009=load('Trinity2009.txt');
LeftOuterBankX=data2009(:,1);
LeftOuterBankY=data2009(:,2);
LeftInnerBankX=data2009(:,3);
LeftInnerBankY=data2009(:,4);
CenterLineX=data2009(:,5);
CenterLineY=data2009(:,6);
RightInnerBankX=data2009(:,7);
RightInnerBankY=data2009(:,8);
RightOuterBankX=data2009(:,9);
RightOuterBankY=data2009(:,10);

%Cropping data vectors so that only existing data are kept
[isdatal,isdatac]=find(~isnan(LeftOuterBankX));LeftOuterBankX=LeftOuterBankX(1:max(isdatal));%151-220
[isdatal,isdatac]=find(~isnan(LeftOuterBankY));LeftOuterBankY=LeftOuterBankY(1:max(isdatal));
[isdatal,isdatac]=find(~isnan(LeftInnerBankX));LeftInnerBankX=LeftInnerBankX(1:max(isdatal));
[isdatal,isdatac]=find(~isnan(LeftInnerBankY));LeftInnerBankY=LeftInnerBankY(1:max(isdatal));
[isdatal,isdatac]=find(~isnan(CenterLineX));CenterLineX=CenterLineX(1:max(isdatal));
[isdatal,isdatac]=find(~isnan(CenterLineY));CenterLineY=CenterLineY(1:max(isdatal));
[isdatal,isdatac]=find(~isnan(RightInnerBankX));RightInnerBankX=RightInnerBankX(1:max(isdatal));
[isdatal,isdatac]=find(~isnan(RightInnerBankY));RightInnerBankY=RightInnerBankY(1:max(isdatal));
[isdatal,isdatac]=find(~isnan(RightOuterBankX));RightOuterBankX=RightOuterBankX(1:max(isdatal));
[isdatal,isdatac]=find(~isnan(RightOuterBankY));RightOuterBankY=RightOuterBankY(1:max(isdatal));
clear isdatal isdatac
l1=length(LeftOuterBankX);
l2=length(LeftInnerBankX);
l3=length(CenterLineX);
l4=length(RightInnerBankX);
l5=length(RightOuterBankX);

%reorganizing data so river points are continuous...
RightOuterBankX=[RightOuterBankX(267:l5);RightOuterBankX(1:266)];
RightOuterBankY=[RightOuterBankY(267:l5);RightOuterBankY(1:266)];
RightInnerBankX=[RightInnerBankX(313:1077);RightInnerBankX(1:312);RightInnerBankX(1078:l4)];
RightInnerBankY=[RightInnerBankY(313:1077);RightInnerBankY(1:312);RightInnerBankY(1078:l4)];
LeftOuterBankX=[LeftOuterBankX(1:150);LeftOuterBankX(221:1803);LeftOuterBankX(1935:1936);LeftOuterBankX(2330:2584);LeftOuterBankX(2716:2970);LeftOuterBankX(2974:3228);LeftOuterBankX(3275:5477);LeftOuterBankX(5871:l1);LeftOuterBankX(2971:2973);LeftOuterBankX(151:220);LeftOuterBankX(1804:1934);LeftOuterBankX(1937:2329);LeftOuterBankX(2585:2715);LeftOuterBankX(5478:5870);LeftOuterBankX(3229:3274)];
LeftOuterBankY=[LeftOuterBankY(1:150);LeftOuterBankY(221:1803);LeftOuterBankY(1935:1936);LeftOuterBankY(2330:2584);LeftOuterBankY(2716:2970);LeftOuterBankY(2974:3228);LeftOuterBankY(3275:5477);LeftOuterBankY(5871:l1);LeftOuterBankY(2971:2973);LeftOuterBankY(151:220);LeftOuterBankY(1804:1934);LeftOuterBankY(1937:2329);LeftOuterBankY(2585:2715);LeftOuterBankY(5478:5870);LeftOuterBankY(3229:3274)];

SL2=5;%half-swipelength
%Running width code with outer banks
[ChanWidthOuter,ChanWidthOuter2,R,coord1outer,coord2outer,width1outer,width2outer,Ox,Oy,xdir,ydir,coordfilt,outerbank1filt,outerbank2filt]=Width(CenterLineX,CenterLineY,LeftOuterBankX,LeftOuterBankY,RightOuterBankX,RightOuterBankY,21,1,0,SL2*2+1,0);

[R,Ox,Oy,coordfilt]=Width(CenterLineX,CenterLineY,NaN,NaN,NaN,NaN,21,1,0,NaN,0);
%Running width code with inner banks
[ChanWidthInner,ChanWidthInner2,R,coord1inner,coord2inner,width1inner,width2inner]=Width(CenterLineX,CenterLineY,LeftInnerBankX,LeftInnerBankY,RightInnerBankX,RightInnerBankY,21,1,0,SL2*2+1,0);

%Plotting river with centerline dots, outer banks crosses, segments joining
%centerline and bank points used for outer-width calculations.
figure;
plot(LeftOuterBankX,LeftOuterBankY,'kx');
hold on
% plot(LeftInnerBankX,LeftInnerBankY,'r');
plot(CenterLineX,CenterLineY,'b.');
% plot(RightInnerBankX,RightInnerBankY,'m');
plot(RightOuterBankX,RightOuterBankY,'gx');
[toplot1,temp]=find(~isnan(coord1outer));[toplot2,temp]=find(~isnan(coord2outer));clear temp;
interval=intersect(toplot1,toplot2);
for j=16:length(CenterLineX)
    x31=coordfilt(j,1);%CenterLineX(j);
    x32=ChanWidthOuter2(j)*xdir(j)*.75;
    y31=coordfilt(j,2);%CenterLineY(j);
    y32=ChanWidthOuter2(j)*ydir(j)*.75;
    plot(linspace(x31-x32,x31+x32,1000),linspace(y31-y32,y31+y32,1000),'k-');
    if ~isempty(intersect(j,interval))
        x11=CenterLineX(j);
        x12=coord1outer(j,1);
        y11=CenterLineY(j);
        y12=coord1outer(j,2);
        x21=CenterLineX(j);
        x22=coord2outer(j,1);
        y21=CenterLineY(j);
        y22=coord2outer(j,2);
        plot(x11:(x12-x11)/999:x12,y11:(y12-y11)/999:y12,'r-');plot(x12,y12,'rx');
        plot(x21:(x22-x21)/999:x22,y21:(y22-y21)/999:y22,'m-');plot(x22,y22,'mx');
        %UNCOMMENT FOLLOWING LINES TO DISPLAY CENTERLINE POINT NUMBER
        %ABOVVE CENTERLINE POINTS WITH AN INCREMENT of 5.
%         if mod(j,5)==0
%             text(CenterLineX(j),CenterLineY(j),num2str(j));
%         end
    end
end
axis tight equal

%Plotting river with centerline dots, inner banks crosses, segments joining
%centerline and bank points used for inner-width calculations.

figure;
% plot(LeftOuterBankX,LeftOuterBankY,'kx');
plot(LeftInnerBankX,LeftInnerBankY,'kx');
hold on
plot(CenterLineX,CenterLineY,'b.');
plot(RightInnerBankX,RightInnerBankY,'gx');
% plot(RightOuterBankX,RightOuterBankY,'gx');
[toplot1,temp]=find(~isnan(coord1inner));[toplot2,temp]=find(~isnan(coord2inner));clear temp;
interval=intersect(toplot1,toplot2);
for j=16:length(CenterLineX)
    if ~isempty(intersect(j,interval))
        x11=CenterLineX(j);
        x12=coord1inner(j,1);
        y11=CenterLineY(j);
        y12=coord1inner(j,2);
        x21=CenterLineX(j);
        x22=coord2inner(j,1);
        y21=CenterLineY(j);
        y22=coord2inner(j,2);
        plot(x11:(x12-x11)/999:x12,y11:(y12-y11)/999:y12,'r-');plot(x12,y12,'rx');
        plot(x21:(x22-x21)/999:x22,y21:(y22-y21)/999:y22,'m-');plot(x22,y22,'mx');
        %UNCOMMENT FOLLOWING LINES TO DISPLAY CENTERLINE POINT NUMBER
        %ABOVVE CENTERLINE POINTS WITH AN INCREMENT of 5.
%         if mod(j,5)==0
%             text(CenterLineX(j),CenterLineY(j),num2str(j));
%         end
    end
end
axis tight equal

%Comparing inner width and outer width. Outer width smaller than inner
%width often means problem with dataset...
figure;
plot(ChanWidthInner,ChanWidthOuter,'+')
hold on
plot((.4:.01:2.6)*10^-3,(.4:.01:2.6)*10^-3,'r-');
axis tight equal

%Any correlation between inner widths and radii of curvature?
figure;
semilogy(ChanWidthInner,abs(R),'+');%Not really...

%Comparing inner and outer half-widths on one side with the other side.
%Helps finding if the centerline is centered...
figure;
plot(width1inner,width2inner,'+');
hold on
plot(width1outer,width2outer,'r+');


figure;%Comparing centeredness of centerline in inner and outer cases
plot(width2inner./width1inner,width2outer./width1outer,'+');
hold on
plot(0:.01:2,(0:.01:2)*.95+.0475,'r-');
xlim([0 2]);ylim([0 2]);